IMPLEMENTATION MODULE Schlange;
  (* 18.4.1989 Broser / Zimmermann : LFB *)

  FROM Storage IMPORT ALLOCATE, DEALLOCATE;

  TYPE  SCHLANGE   = POINTER TO Element;

        Element = RECORD
                    Wert : CHAR;
                    next : SCHLANGE;
                  END;

  VAR
    Anker      : SCHLANGE;
    Zeichen    : CHAR;


  PROCEDURE newSchlange();
  BEGIN
    Anker := NIL;
  END newSchlange;

  PROCEDURE isEmptySchlange() : BOOLEAN;
  BEGIN
    RETURN ( Anker = NIL );
  END isEmptySchlange;

  PROCEDURE append( c : CHAR );
    PROCEDURE Put( VAR Pointer : SCHLANGE );
    BEGIN
      IF Pointer = NIL
      THEN
        NEW( Pointer );
        Pointer^.Wert:= c;
        Pointer^.next:= NIL
      ELSE
        Put( Pointer^.next );
      END
    END Put;

  BEGIN
   Put( Anker );
  END append;

  PROCEDURE first() : CHAR;
  VAR
    Hilf : SCHLANGE;
    ch   : CHAR;
  BEGIN
    IF isEmptySchlange()
    THEN
      RETURN "!"
    ELSE
      ch:= Anker^.Wert;
      Hilf:= Anker;
      Anker:= Anker^.next;
      DISPOSE( Hilf );
      RETURN ch
    END
  END first;

END Schlange.

