IMPLEMENTATION MODULE Stack;
  (* 18.4.1989 Broser / Zimmermann : LFB *)

  FROM Storage IMPORT ALLOCATE, DEALLOCATE;

  TYPE  STACK   = POINTER TO Element;

        Element = RECORD
                    Wert : CHAR;
                    next : STACK;
                  END;

  VAR
    Anker      : STACK;
    Zeichen    : CHAR;


  PROCEDURE newStack();
  BEGIN
    Anker := NIL;
  END newStack;

  PROCEDURE isEmptyStack() : BOOLEAN;
  BEGIN
    RETURN ( Anker = NIL );
  END isEmptyStack;

  PROCEDURE push( c : CHAR );
  VAR
    Zwerg : STACK;
  BEGIN
    Zwerg:= Anker;
    NEW( Anker );
    Anker^.Wert:= c;
    Anker^.next:= Zwerg;
  END push;

  PROCEDURE pop() : CHAR;
  VAR
    Hilf : STACK;
    ch   : CHAR;
  BEGIN
    IF isEmptyStack()
    THEN
      RETURN "!"
    ELSE
      ch:= Anker^.Wert;
      Hilf:= Anker;
      Anker:= Anker^.next;
      DISPOSE( Hilf );
      RETURN ch
    END
  END pop;

END Stack.

