IMPLEMENTATION MODULE sort2;
(* C: Broser , LFB Informatik, 24.5.89        *)
(* Realisierung als binrer Baum, verbesserte Version von 1988 *)

FROM Storage IMPORT ALLOCATE, DEALLOCATE;

FROM formatausgabe IMPORT WriteRText, WriteLText;

FROM Strings IMPORT CompareStr;

FROM InOut IMPORT WriteString,WriteLn;


TYPE tKnoten = POINTER TO tStruktur;
     tStruktur = RECORD
                   info: tDatensatz;
                   linkerZweig,rechterZweig: tKnoten
                 END;


PROCEDURE NeuerKnoten(VAR z: tKnoten;datensatz:tDatensatz);
   BEGIN
       NEW(z);
       z^.linkerZweig := NIL;
       z^.rechterZweig:= NIL;
       z^.info := datensatz;
   END NeuerKnoten;


PROCEDURE einfuegen(VAR zeiger:tKnoten;datensatz:tDatensatz);
  VAR neuzeiger : tKnoten;

  BEGIN
    IF zeiger = NIL
     THEN NeuerKnoten(zeiger,datensatz)
     ELSIF CompareStr(datensatz[1],zeiger^.info[1]) < 0
           THEN einfuegen(zeiger^.linkerZweig,datensatz)
     ELSE einfuegen(zeiger^.rechterZweig,datensatz)
    END; (* of IF *)
  END einfuegen;

PROCEDURE ausfuegen(VAR zeiger: tKnoten; Wort:STRING);
   VAR
     hilfszeiger : tKnoten;

     PROCEDURE del(VAR r : tKnoten);
              BEGIN
                IF r^.rechterZweig <> NIL
                  THEN del(r^.rechterZweig)
                  ELSE hilfszeiger^.info := r^.info;
                       hilfszeiger := r;
                       r := r^.linkerZweig;
                 END;
      END del;

   BEGIN  (* ausfuegen *)
        IF zeiger = NIL
          THEN WriteString('Datensatz ist nicht vorhanden ! ');WriteLn
        ELSIF CompareStr(Wort,zeiger^.info[1])< 0
          THEN  ausfuegen(zeiger^.linkerZweig,Wort)
        ELSIF CompareStr(Wort,zeiger^.info[1]) > 0
          THEN  ausfuegen(zeiger^.rechterZweig,Wort)
        ELSE
           hilfszeiger := zeiger;
           IF zeiger^.rechterZweig = NIL
            THEN  zeiger := zeiger^.linkerZweig
           ELSIF zeiger^.linkerZweig = NIL
            THEN  zeiger := zeiger^.rechterZweig
           ELSE del(zeiger^.linkerZweig)
           END;
         DISPOSE(hilfszeiger);
       END;

   END ausfuegen;

PROCEDURE ausgebenDatensatz( z: tKnoten);
   BEGIN
      WriteLText(z^.info[1],15);
      WriteLText(z^.info[2],15);
      WriteLText(z^.info[3],15);
      WriteLText(z^.info[4],15);
      WriteLText(z^.info[5],15);
      WriteLn;
   END ausgebenDatensatz;

PROCEDURE DatensatzAusgeben(VAR z: tKnoten; Wort:STRING);
    BEGIN
      IF  z = NIL
            THEN WriteString('Datensatz ist nicht vorhanden .');
                 WriteLn;
      ELSIF CompareStr(Wort,z^.info[1])< 0
            THEN DatensatzAusgeben(z^.linkerZweig,Wort)
      ELSIF CompareStr(Wort,z^.info[1]) > 0
            THEN DatensatzAusgeben(z^.rechterZweig,Wort)
      ELSE  ausgebenDatensatz(z)
      END;  (* of IF *)
    END DatensatzAusgeben;

PROCEDURE ListeAusgeben(VAR zeiger:tKnoten);
   BEGIN
        IF zeiger <> NIL
          THEN ListeAusgeben(zeiger^.linkerZweig);
               ausgebenDatensatz(zeiger);
               ListeAusgeben(zeiger^.rechterZweig)  END;
    END ListeAusgeben;

BEGIN
  wurzel := NIL;
END sort2.